rem setup-xcollection.cmd
rem
rem This command creates, enables, and populates the XML Collection tables
rem in the SALES_DB database for the dxx_sales_db Web Services group.
rem
rem Arthur Ryman
rem 2001-06-14

rem Run setup-database.cmd to create the database before running this command.
rem Run this command from a DB2 Command Window in the dxx_sales_db directory.

db2 "connect to SALES_DB"

rem Insert DTDs
db2 "insert into db2xml.dtd_ref values('getstart.dtd', db2xml.XMLClobFromFile('%CD%\getstart.dtd'), 0, 'user1', 'user1', 'user1')"
db2 "insert into db2xml.dtd_ref values('order.dtd', db2xml.XMLClobFromFile('%CD%\order.dtd'), 0, 'user1', 'user1', 'user1')"

rem Create the tables for XML Collection access

db2 "create table order_tab(order_key integer, customer_name varchar(16), customer_email varchar(16), customer_phone varchar(16))"
db2 "create table part_tab(part_key integer, color char(6), quantity integer, price decimal(10,2), tax real, order_key integer)"
db2 "create table ship_tab(date date, mode char(6), comment varchar(64), part_key integer)"

rem Populate the tables

db2 "insert into order_tab values(1, 'American Motors', 'parts@am.com', '800-AM-PARTS')"
db2 "insert into part_tab values(156, 'red', 17, 17954.55, 0.02, 1)"
db2 "insert into part_tab values(68, 'black', 36, 34850.16, 0.06, 1)"
db2 "insert into part_tab values(128, 'red', 28, 38000.00, 0.07, 1)"
db2 "insert into ship_tab values('1998-03-13', 'TRUCK', 'This is the first shipment to service of AM.', 156)"
db2 "insert into ship_tab values('1999-01-16', 'FEDEX', 'This the second shipment to service of AM.', 156)"
db2 "insert into ship_tab values('1998-08-19', 'BOAT', 'This shipment is requested by a call. from AM marketing.', 68)"
db2 "insert into ship_tab values('1998-08-19', 'AIR', 'This shipment is ordered by an email.', 68)"
db2 "insert into ship_tab values('1998-12-30', 'TRUCK', NULL, 128)"

db2 "terminate"

rem Enable the XML Collections

dxxadm enable_collection sales_db getstartSQL getstart_xcollection.dad
dxxadm enable_collection sales_db getstartRDB getstart_xcollection-rdb.dad
dxxadm enable_collection sales_db orderRDB order.dad