rem setup-xcolumn.cmd
rem
rem This command creates, enables, and populates the XML Column tables in 
rem the SALES_DB database for the dxx_sales_db Web Services group.
rem
rem Arthur Ryman
rem 2001-06-14

rem Run setup-database.cmd before running this command.
rem Run this command from a DB2 Command Window in the dxx_sales_db directory.


db2 "connect to SALES_DB"

rem Create table for XML Column access
db2 "create table sales_tab(invoice_num char(6) not null primary key, sales_person varchar(20), order db2xml.xmlvarchar)"

db2 "terminate"

rem  Enable the column for XML Column access
dxxadm enable_column sales_db sales_tab order getstart_xcolumn.dad -v sales_order_view -r invoice_num

db2 "connect to SALES_DB"

rem Create indices on the side tables
db2 "create index key_idx on order_side_tab(order_key)"
db2 "create index customer_idx on order_side_tab(customer)"
db2 "create index price_idx on part_side_tab(price)"
db2 "create index date_idx on ship_side_tab(date)"

rem Populate the table
db2 "insert into sales_tab(invoice_num, sales_person, order) values('123456', 'Sriram Srinivasan', db2xml.XMLVarcharFromFile('%CD%\getstart.xml'))"
db2 "insert into sales_tab(invoice_num, sales_person, order) values('123457', 'Bob Smith', db2xml.XMLVarcharFromFile('%CD%\order-10.xml'))"

db2 "terminate"