package proxy.response.generated;

import java.util.*;
import java.text.DateFormat;
import com.ibm.etools.xmlschema.beans.*;

/**
* Provides convenience methods for creating Java beans for elements
* in this XML document
*/
public class responseFactory extends Factory
{
  public responseFactory()
  {
    super();
  }
  
  /**
  * Create the Java bean response for the root element
  *   @param rootElementname The tag for the root element
  *   @return response The Java bean representing this element
  */
  public response createRoot(String rootElementname)
  {
    return (response) createRootDOMFromComplexType("response",rootElementname);
  }
  
  /**
  * Create the Java bean response by loading the XML file
  *   @param filename The XML file name
  *   @return response The Java bean representing the root element
  */
  public response loadDocument(String filename)
  {
    return (response) loadDocument("response",filename);
  }
  
  /**
  * Create the Java bean response for the element
  *   @param elementName The tag for the element
  *   @return response The Java bean representing this element
  */
  public response createresponse(String elementName)
  {
    return (response) createDOMElementFromComplexType("response",elementName);
  }
  
  /**
  * Create the Java bean ACCTNO for the element
  *   @param elementName The tag for the element
  *   @return ACCTNO The Java bean representing this element
  */
  public ACCTNO createACCTNO(String elementName)
  {
    return (ACCTNO) createDOMElementFromSimpleType("ACCTNO",elementName);
  }
  
  /**
  * Create the Java bean SSN for the element
  *   @param elementName The tag for the element
  *   @return SSN The Java bean representing this element
  */
  public SSN createSSN(String elementName)
  {
    return (SSN) createDOMElementFromSimpleType("SSN",elementName);
  }
  
  /**
  * Create the Java bean ADDRLINE for the element
  *   @param elementName The tag for the element
  *   @return ADDRLINE The Java bean representing this element
  */
  public ADDRLINE createADDRLINE(String elementName)
  {
    return (ADDRLINE) createDOMElementFromSimpleType("ADDRLINE",elementName);
  }
  
  /**
  * Create the Java bean CITY for the element
  *   @param elementName The tag for the element
  *   @return CITY The Java bean representing this element
  */
  public CITY createCITY(String elementName)
  {
    return (CITY) createDOMElementFromSimpleType("CITY",elementName);
  }
  
  /**
  * Create the Java bean STATE for the element
  *   @param elementName The tag for the element
  *   @return STATE The Java bean representing this element
  */
  public STATE createSTATE(String elementName)
  {
    return (STATE) createDOMElementFromSimpleType("STATE",elementName);
  }
  
  /**
  * Create the Java bean COUNTRY for the element
  *   @param elementName The tag for the element
  *   @return COUNTRY The Java bean representing this element
  */
  public COUNTRY createCOUNTRY(String elementName)
  {
    return (COUNTRY) createDOMElementFromSimpleType("COUNTRY",elementName);
  }
  
  /**
  * Create the Java bean POLICYNUM for the element
  *   @param elementName The tag for the element
  *   @return POLICYNUM The Java bean representing this element
  */
  public POLICYNUM createPOLICYNUM(String elementName)
  {
    return (POLICYNUM) createDOMElementFromSimpleType("POLICYNUM",elementName);
  }
  
  /**
  * Create the Java bean COVERAGEAMOUNT for the element
  *   @param elementName The tag for the element
  *   @return COVERAGEAMOUNT The Java bean representing this element
  */
  public COVERAGEAMOUNT createCOVERAGEAMOUNT(String elementName)
  {
    return (COVERAGEAMOUNT) createDOMElementFromSimpleType("COVERAGEAMOUNT",elementName);
  }
  
}

