package proxy.soap;

import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.xml.*;
import org.apache.soap.messaging.*;
import org.apache.soap.transport.http.*;

public class InsuranceServiceBeanProxy
{
  private Call call;
  private URL url = null;
  private String stringURL = "http://localhost:9080/InsuranceProj/servlet/rpcrouter";
  private java.lang.reflect.Method setTcpNoDelayMethod;

  public InsuranceServiceBeanProxy()
  {
    try
    {
      setTcpNoDelayMethod = SOAPHTTPConnection.class.getMethod("setTcpNoDelay", new Class[]{Boolean.class});
    }
    catch (Exception e)
    {
    }
    call = createCall();
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }

  public synchronized org.w3c.dom.Element processClaim(java.lang.String patientName,java.lang.String chargeAmount,java.lang.String serviceDate,java.lang.String serviceType,java.lang.String ssn) throws Exception
  {
    String targetObjectURI = "http://tempuri.org/com.ibm.b2b.examples.insurance.InsuranceServiceBean";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via InsuranceServiceBeanProxy.setEndPoint(URL).");
    }

    call.setMethodName("processClaim");
    call.setEncodingStyleURI(Constants.NS_URI_LITERAL_XML);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    Parameter patientNameParam = new Parameter("patientName", java.lang.String.class, patientName, Constants.NS_URI_SOAP_ENC);
    params.addElement(patientNameParam);
    Parameter chargeAmountParam = new Parameter("chargeAmount", java.lang.String.class, chargeAmount, Constants.NS_URI_SOAP_ENC);
    params.addElement(chargeAmountParam);
    Parameter serviceDateParam = new Parameter("serviceDate", java.lang.String.class, serviceDate, Constants.NS_URI_SOAP_ENC);
    params.addElement(serviceDateParam);
    Parameter serviceTypeParam = new Parameter("serviceType", java.lang.String.class, serviceType, Constants.NS_URI_SOAP_ENC);
    params.addElement(serviceTypeParam);
    Parameter ssnParam = new Parameter("ssn", java.lang.String.class, ssn, Constants.NS_URI_SOAP_ENC);
    params.addElement(ssnParam);
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((org.w3c.dom.Element)refValue.getValue());
    }
  }

  protected Call createCall()
  {
    SOAPHTTPConnection soapHTTPConnection = new SOAPHTTPConnection();
    if ( setTcpNoDelayMethod != null)
    {
      try
      {
        setTcpNoDelayMethod.invoke(soapHTTPConnection, new Object[]{Boolean.TRUE});
      }
      catch (Exception ex)
      {
      }
    }
    Call call = new Call();
    call.setSOAPTransport(soapHTTPConnection);
    SOAPMappingRegistry smr = call.getSOAPMappingRegistry();
    return call;
  }
}
