package proxy.soap;

import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.xml.*;
import org.apache.soap.messaging.*;
import org.apache.soap.transport.http.*;

public class patientProxy
{
  private Call call;
  private URL url = null;
  private String stringURL = "http://localhost:9080/PatientProj/patientGroup/patient.dadx/SOAP";
  private java.lang.reflect.Method setTcpNoDelayMethod;

  public patientProxy()
  {
    try
    {
      setTcpNoDelayMethod = SOAPHTTPConnection.class.getMethod("setTcpNoDelay", new Class[]{Boolean.class});
    }
    catch (Exception e)
    {
    }
    call = createCall();
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }

  public synchronized org.w3c.dom.Element findPatient_(int acct) throws Exception
  {
    String targetObjectURI = "http://tempuri.org/patientGroup/patient.dadx";
    String SOAPActionURI = "http://tempuri.org/patientGroup/patient.dadx";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via patientProxy.setEndPoint(URL).");
    }

    call.setMethodName("findPatient");
    call.setEncodingStyleURI(Constants.NS_URI_LITERAL_XML);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    Parameter acctParam = new Parameter("acct", int.class, new Integer(acct), Constants.NS_URI_SOAP_ENC);
    params.addElement(acctParam);
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((org.w3c.dom.Element)refValue.getValue());
    }
  }

  public synchronized org.tempuri.patientproj.patientgroup.patient.dadx.xsd.FindPatientResultElement findPatient(int acct) throws Exception
  {

    // delegate to method findPatient_
    org.w3c.dom.Element result_ = findPatient_(acct);

    // convert result_ from an org.w3c.dom.Element to org.tempuri.patientproj.patientgroup.patient.dadx.xsd.FindPatientResultElement
    org.tempuri.patientproj.patientgroup.patient.dadx.xsd.FindPatientResultElement aFindPatientResultElement = new org.tempuri.patientproj.patientgroup.patient.dadx.xsd.FindPatientResultElement();
    aFindPatientResultElement.populateFrom(result_);

    return aFindPatientResultElement;
  }


  protected Call createCall()
  {
    SOAPHTTPConnection soapHTTPConnection = new SOAPHTTPConnection();
    if ( setTcpNoDelayMethod != null)
    {
      try
      {
        setTcpNoDelayMethod.invoke(soapHTTPConnection, new Object[]{Boolean.TRUE});
      }
      catch (Exception ex)
      {
      }
    }
    Call call = new Call();
    call.setSOAPTransport(soapHTTPConnection);
    SOAPMappingRegistry smr = call.getSOAPMappingRegistry();
    return call;
  }
}
